import numpy, cv2, math

cap = cv2.VideoCapture(0)

def drawKeypoints(image, kp, color):
    for p in kp:
        pos = (int(p.pt[0]), int(p.pt[1]))
        pos1 = (int(p.pt[0]+p.size*math.cos(p.angle/180*math.pi)),\
                int(p.pt[1]+p.size*math.sin(p.angle/180*math.pi)))
        scale = int(p.size)
        cv2.circle(image, pos, scale, color=(0,0,255), thickness=1)
        cv2.line(image, pos, pos1, color=(0,0,255), thickness=2)

sift = cv2.xfeatures2d.SIFT_create(500) # Num of keypoints
#sift = cv2.ORB_create(100)

while 1:
    stat, image = cap.read(0)
    image = cv2.resize(image, ((int)(image.shape[1]/2),(int)(image.shape[0]/2)))

    kp = sift.detect(image)
    kp, des = sift.compute(image, kp)
    drawKeypoints(image, kp, color=(255,0,0))    

    cv2.imshow('Camera', image)
    key = cv2.waitKey(10)

    if key == 0x1b: # ESC
        break
