import numpy, cv2

cap = cv2.VideoCapture(0)
max_pts = 300
sift = cv2.xfeatures2d.SIFT_create(max_pts)

#bf = cv2.BFMatcher(cv2.NORM_HAMMING, crossCheck=False) # Bruteforce matcher
bf = cv2.BFMatcher(cv2.NORM_L2, crossCheck=True) # Bruteforce matcher
desc0 = None # To store descriptors
color = numpy.random.randint(0, 255, (max_pts, 3)) # Random color for kp

while 1:
    stat, image = cap.read(0)
    image = cv2.resize(image, ((int)(image.shape[1]/2), (int)(image.shape[0]/2)))

    # Find keypoints and their descriptors
    kp = sift.detect(image)
    kp, desc = sift.compute(image, kp)
    cv2.drawKeypoints(image, kp, image, color=(0,255,0))

    if desc0 != None:
        # Match the saved and the latest kp's
        matches = bf.match(desc0, desc)

        for i in range(min(max_pts,len(matches))):
            # Matched pair: kp0[m.queryIdx] <--> kp[m.trainIdx]
            m = matches[i]
            if m.distance > 0.3: # thresholding
                continue
            (a, b) = kp[m.trainIdx].pt
            (c, d) = kp0[m.queryIdx].pt
            cv2.circle(image, (int(a), int(b)), 5,\
                       color[m.queryIdx%max_pts].tolist(), -1)
            cv2.line(image, (int(a), int(b)), (int(c), int(d)),\
                     color[m.queryIdx%max_pts].tolist(), 2)

    cv2.imshow('Camera', image)
    key = cv2.waitKey(10)

    if key == 0x1b: # ESC
        break
    elif key == 0x20:
        desc0 = desc.copy()
        kp0 = kp[:]
        print ('Target updated!')
