import numpy, cv2

cap = cv2.VideoCapture(0)
cv2.ocl.setUseOpenCL(False)
#sift = cv2.xfeatures2d.SIFT_create(500)
sift = cv2.xfeatures2d.SURF_create(500)

# FLANN matcher
FLANN_INDEX_KDTREE = 0
FLANN_INDEX_LSH = 6
#index_params = dict(algorithm = FLANN_INDEX_KDTREE, trees = 5)
index_params = dict(algorithm = FLANN_INDEX_LSH, table_number = 6, key_size = 12, multi_probe_level = 1)
search_params = dict() # dict(checks=50)
flann = cv2.FlannBasedMatcher(index_params, search_params)

# Bruteforce matcher
bf = cv2.BFMatcher(cv2.NORM_L2,crossCheck=False) 

x, y, w, h = 320-150, 240-150, 300, 300
num_objs, desc = 0, None
kp_lbls, target_imgs = [], []
desc = numpy.zeros((1,1))

while 1:
    stat, image = cap.read(0)
    image = cv2.resize(image, (800, 480))
    disp = image.copy()

    # Find keypoints and their descriptors
    kp1 = sift.detect(image, None)
    kp1, desc1 = sift.compute(image, kp1)
    cv2.drawKeypoints(image, kp1, disp, color=(0,255,0))
    cv2.rectangle(disp, (x, y), (x+w, y+h), 255, 2)

    if desc.shape[0] != 1:
        #matches = flann.knnMatch(desc1, 2)
        #matches = flann.knnMatch(desc1, desc, 2)
        matches = bf.knnMatch(desc1, desc, 2)

        hist = [0] * num_objs
        for m in matches:
            if m[0].distance > m[1].distance*0.7:
                continue
            hist[kp_lbls[m[0].trainIdx]] += 1

        print( 'histogram = ', hist)
        pred = max(enumerate(hist),key=lambda x: x[1])[0]
        cv2.imshow('Reconized', target_imgs[pred]);

    cv2.imshow('Camera', disp)
    key = cv2.waitKey(50)
    if key == 0x1b: # ESC
        break
    elif key == 0x20:
        kp_lbls = kp_lbls + [num_objs]*len(desc1) 
        if desc.shape[0] != 1:
            desc = numpy.concatenate((desc, desc1))
            target_imgs += [image]
        else:
            desc = desc1.copy()
            target_imgs = [image]
        #flann.add([desc])
        #flann.train()
        num_objs = num_objs + 1
        print( 'Target updated!')
